
enum SIZE {
    //% block="29*29"
    1,
    //% block="58*58"
    2
}

enum LINE {
    //% block="1"
    1,
    //% block="2"
    2,
    //% block="3"
    3,
    //% block="4"
    4
}

enum BTN {
    //% block="A"
    A,
    //% block="B"
    B,
    //% block="A+B"
    AB
}


//% color="#AA278D" iconWidth=50 iconHeight=40
namespace tinycar {

    //% block="小车前进速度:[sudu]" blockType="command"
    //% sudu.shadow="range"   sudu.params.min=0    sudu.params.max=255    sudu.defl=255
    export function F(parameter: any, block: any) {
        let sudu = parameter.sudu.code;
        Generator.addInclude('tinecarlibraray','#include "tinycar.h"');
        Generator.addSetup("wire.begin", `Wire.begin();`);
        Generator.addCode(`dianji(${sudu},0,${sudu},0);`);
    }

    //% block="小车后退速度:[sudu2]" blockType="command"
    //% sudu2.shadow="range"   sudu2.params.min=0    sudu2.params.max=255    sudu2.defl=255
    export function B(parameter: any, block: any) {
        let sudu2 = parameter.sudu2.code;
        Generator.addInclude('tinecarlibraray','#include "tinycar.h"');
        Generator.addSetup("wire.begin", `Wire.begin();`);
        Generator.addCode(`dianji(0,${sudu2},0,${sudu2});`);
    }

    //% block="小车左转速度:[sudu3]" blockType="command"
    //% sudu3.shadow="range"   sudu3.params.min=0    sudu3.params.max=255    sudu3.defl=255
    export function L(parameter: any, block: any) {
        let sudu3 = parameter.sudu3.code;
        Generator.addInclude('tinecarlibraray','#include "tinycar.h"');
        Generator.addSetup("wire.begin", `Wire.begin();`);
        Generator.addCode(`dianji(0,0,${sudu3},0);`);
    }

    //% block="小车右转速度:[sudu4]" blockType="command"
    //% sudu4.shadow="range"   sudu4.params.min=0    sudu4.params.max=255    sudu4.defl=255
    export function R(parameter: any, block: any) {
        let sudu4 = parameter.sudu4.code;
        Generator.addInclude('tinecarlibraray','#include "tinycar.h"');
        Generator.addSetup("wire.begin", `Wire.begin();`);
        Generator.addCode(`dianji(${sudu4},0,0,0);`);
    }

    //% block="小车前进速度:左轮[sudu5]右轮[sudu6]" blockType="command"
    //% sudu5.shadow="range"   sudu5.params.min=0    sudu5.params.max=255    sudu5.defl=255
    //% sudu6.shadow="range"   sudu6.params.min=0    sudu6.params.max=255    sudu6.defl=255
    export function FLR(parameter: any, block: any)  {
        let sudu5 = parameter.sudu5.code;
        let sudu6 = parameter.sudu6.code;
        Generator.addInclude('tinecarlibraray','#include "tinycar.h"');
        Generator.addSetup("wire.begin", `Wire.begin();`);
        Generator.addCode(`dianji(${sudu5},0,${sudu6},0);`);
    }

    //% block="小车后退速度:左轮[sudu7]右轮[sudu8]" blockType="command"
    //% sudu7.shadow="range"   sudu7.params.min=0    sudu7.params.max=255    sudu7.defl=255
    //% sudu8.shadow="range"   sudu8.params.min=0    sudu8.params.max=255    sudu8.defl=255
    export function BLR(parameter: any, block: any)  {
        let sudu7 = parameter.sudu7.code;
        let sudu8 = parameter.sudu8.code;
        Generator.addInclude('tinecarlibraray','#include "tinycar.h"');
        Generator.addSetup("wire.begin", `Wire.begin();`);
        Generator.addCode(`dianji(0,${sudu7},0,${sudu8});`);
    }

    //% block="小车原地左转速度:[sudu9]" blockType="command"
    //% sudu9.shadow="range"   sudu9.params.min=0    sudu9.params.max=255    sudu9.defl=255
    export function LL(parameter: any, block: any)  {
        let sudu9 = parameter.sudu9.code;
        Generator.addInclude('tinecarlibraray','#include "tinycar.h"');
        Generator.addSetup("wire.begin", `Wire.begin();`);
        Generator.addCode(`dianji(0,${sudu9},${sudu9},0);`);
    }

    //% block="小车原地右转速度:[sudu10]" blockType="command"
    //% sudu10.shadow="range"   sudu10.params.min=0    sudu10.params.max=255    sudu10.defl=255
    export function RR(parameter: any, block: any)  {
        let sudu10 = parameter.sudu10.code;
        Generator.addInclude('tinecarlibraray','#include "tinycar.h"');
        Generator.addSetup("wire.begin", `Wire.begin();`);
        Generator.addCode(`dianji(${sudu10},0,0,${sudu10});`);
    }

    //% block="小车探照灯颜色:R[R]G[G]B[B]" blockType="command"
    //% R.shadow="range"   R.params.min=0    R.params.max=255    R.defl=255
    //% G.shadow="range"   G.params.min=0    G.params.max=255    G.defl=255
    //% B.shadow="range"   B.params.min=0    B.params.max=255    B.defl=255
    export function RGB(parameter: any, block: any)  {
        let R = parameter.R.code;
        let G = parameter.G.code;
        let B = parameter.B.code;
        Generator.addInclude('tinecarlibraray','#include "tinycar.h"');
        Generator.addSetup("wire.begin", `Wire.begin();`);
        Generator.addCode(`RGB(${R},${G},${B});`);
    }

}
